/* tool/map.js
  created sam. oct. 20 01:15:17 CEST 2012 by whygee@f-cpu.org

*/

init_obj.push(Map={
  MapList:[],
  MapCount:1,


///////////////////////
  NewMem: function(w,a,rwx,c,f,l){ // f & l can be optional / left out during call
    w.memory={
      mem:[],
      Align:a,
      first:f,
      last:l,
      rwx:rwx,
      callback:c
    }
  },


/////////////////////// Export


  export_MAP:function(){},
  export_ASM:function(){},
  export_HEX:function(){},
  export_VHDL:function(){},


/////////////////////// Manage the selection of the map (included in other windows)

  openMap: function(){
    var m=wa("tool/map"),
        s=parentWin(this);
    if(s.regs)
      Map.addSim(s,m);
    else
      Map.addEdit(s,m);
    delay(Map.mapSelDelay);
  },

  createMapSel:function(w){
    var d=dcE("DIV"),
        e=dcE("DIV"),
        f=d.style;

    f.whiteSpace="pre";
    f.position="relative";
    f.cssFloat="right";
    f.border="1px solid #AAA";

//       (f=dcE("BUTTON")).innerHTML=I8N("canm");
//        f.onclick=Map.openMap;
//      e.appendChild(f);
      button(e,"canm",Map.openMap);
      e.appendChild(w.MapSel
            =dcE("FORM"));
    h3(d,e,"aja");  // add e to d
    delay(Map.mapSelDelay);
    return d;
  },

  focusParent:function(){
    ygwm.focus_window(0,this.parentNode.w);
  },
  focusDiv:function(){
    ygwm.focus_window(0,this.w);
  },

///////////////////////////////////////////////////////////

  changeEdit:function(){
    var e=parentWin(this),  // the edit window
        m=this.parentNode.w;  // the map window
    if (this.checked)
      Map.addEdit(e,m);
    else
      Map.delEdit(e,m);
  },

  addEdit:function(e,m){
    e.Maps[m.MapCount]=m;
    m.edList[e.YasCount]=e;
    var d=Map.makeLine(e,Map.buttonDelEdit);
    e.MapDiv[m.MapCount]=d;
    m.edListDiv.appendChild(d);
  },

  buttonDelEdit:function(){
    Map.delEdit(this.parentNode.w,parentWin(this));
  },

  delEdit:function(e,m){
    var f=e.MapDiv[m.MapCount];
    f.parentNode.removeChild(f);
    delete m.edList[e.YasCount];
    delete e.Maps[m.MapCount];
    delay(Map.mapSelDelay);
  },

///////////////////////////////////////////////////////////

  makeLine:function(u,c){
    // add a line
    var d=dcE("DIV"),
        f=dcE("DIV");
    d.innerHTML=u.winTitle;
    d.w=u;
    d.className="BPitem";
    d.onclick=Map.focusDiv;
      f.className="minus";
      f.onclick=c;
      f.title=I8N("dtl");
    d.appendChild(f);
    delay(Map.mapSelDelay);
    return d;
  },

///////////////////////////////////////////////////////////

  changeSim:function(){
    var s=parentWin(this);  // the sim window
    if (this.checked)
      Map.addSim(s,
         this.parentNode.w);   // the map window
    else
      Map.delSim(s);
  },

  addSim:function(s,m){
    if(s.Map)
      Map.delSim(s);
    s.Map=m;
    sim.resetState(s); // Force re-init
    m.simListDiv.appendChild(
       s.MapDiv
          =Map.makeLine(s,Map.buttonDelSim));
    m.simList[s.simCount]=s;
  },

  buttonDelSim:function(){
    Map.delSim(this.parentNode.w);
  },

  delSim:function(s){
    m=s.Map; // The map is implicit because there can be only one...
    if(m && m.simList){ // the sim may be disconnected and/or ERASED
      delete m.simList[s.simCount];
      s.MapDiv.parentNode.removeChild(s.MapDiv);
    }
    s.Map=null;
    sim.resetState(s,6); // force "DISCONNECTED" and refresh all the sim
    delay(Map.mapSelDelay);
  },

///////////////////////////////////////////////////////////

/*
  listMaps: function(){
    var i,j="open maps: ";
    for (i in Map.MapList)
      j+=Map.MapList[i].MapCount+"\n";
    alert(j);
  },
*/

  mapSelDelay:{
    delay:500, // ms
    max:20,
    counter:20,
    timer:null,
    func:function(){
// better strategy would be : create 2 "templates" and clone them
// (because it's the same list over and over)
      var w, j, d, e,g,i,j;
      // scan the list of open windows
      for (j in winlist.list){
      // seek a MapSel property:
        w=winlist.list[j];
        if (d=w.MapSel) {
          d.innerHTML=""; // flush the div!

          for (i in Map.MapList){
            (e=dcE("DIV")).w=Map.MapList[i];
             e.className="BPitem";

               g=dcE("INPUT");
                if(w.regs){ // Is it a simulator ?
                  g.name=w.simCount; // add "name" so the radiobutton works
                  g.type="radio";
                  g.onchange=Map.changeSim;
                  if (w.Map && w.Map==e.w)
                    g.checked=true;
                }
                else{ // framebuffer or YASMed
                  g.type="checkbox";
                  g.onchange=Map.changeEdit;
                  if (w.Maps[e.w.MapCount]==e.w)
                    g.checked=true;
                }
              e.appendChild(g);

                (g=dcE("SPAN")).innerHTML=e.w.winTitle;
                 g.onclick=Map.focusParent;
                 g.style.cursor="pointer";
              e.appendChild(g);

            d.appendChild(e);
          }
        }
      }
    }
  },

  removeMap: function(m){
    // remove itself from the list of maps
    delete Map.MapList[m.MapCount];

    // scan the list of connected sims and disconnect everything
    for (var i in m.simList)
       Map.delSim(m.simList[i]);
    // idem for editors
    for (var i in m.edList)
      Map.delEdit(m.edList[i],m);

    // refresh all the sims and YASMed
    delay(Map.mapSelDelay);
  },

///////////////////////////////////////////////////////////


/*
  access: function(m, o, a, rwx){ // map, object, address, rights
    var h=o.hint, d, v;

// DEBUG
    if (typeof(a)!="number" || (a&1))
      alert("internal error\n"
       +" address = "+a);
    // 1) lookup : try the hint first
    if (!h
    ||  !h.memory
    || ((x&1)&&!h.memory[a] )  ){

    }
  },

  accessRead: function(m,o,a,rwx){ // map, object, address, requested rights (r=4, x=1)

// DEBUG
    if (typeof(a)!="number" || (a&1))
      alert("internal error\n" 
       +" address = "+a);

    

  },

  accessWrite: function(m,o,a,v){

// DEBUG
    if (typeof(a)!="number" || (a&1))
      alert("internal error\n"
       +" write address = "+a);
    if (typeof(v)!="number" || (a&F4)!=a)
      alert("internal error\n"
       +" write value = "+a);



  },
*/


///////////////////////////////////////////////////////////


  start: function() {
    var cont=dcE("DIV"), c,
      d=dcE("DIV"),
      e,f,g,
      w = ygwm.new_window(
         I8N("Mp")+" #"+Map.MapCount, null, cont,
         400, 500, 100, 170, false, true, true, true, false, "doc_blue");

    cont.innerHTML=WARN+'stay tuned...<br>';

      d=dcE("DIV");
      button(d,"yaem",Map.export_MAP,0,"1em");
      button(d,"yaea",Map.export_ASM,0,"1em");
      button(d,"yahy",Map.export_HEX,0,"1em"); // Enlever les '"'
      button(d,"yavh",Map.export_VHDL,0,"1em");
    cont.appendChild(d);

      (d=dcE("DIV")).innerHTML=
         '<div>Data&amp;instruction memories: '
        +'<input name="di'+Map.MapCount+'" type="radio" checked="checked"> unified '
        +'<input name="di'+Map.MapCount+'" type="radio"> split<div>';
    h3(cont, d,"cnf");

/*
+'<input name="di'+Map.MapCount+'" type="radio"> unified data&amp;instruction '
+'<input name="di'+Map.MapCount+'" type="radio"> split data and instructions memories<p>'
+'<input type="checkbox"> Read'
+'<input type="checkbox"> Write'
+'<input type="checkbox"> eXecute'
*/
;

/*
 //    for later :
    button(d,"yara",emptyFunc,0,"1em");
    button(d,"yaea",emptyFunc,0,"1em");
    button(d,"yahy",emptyFunc,0,"1em");
    button(d,"yavh",emptyFunc,0,"1em");
*/


    w.eraseCallback=Map.removeMap;

    w.simList=[];
    w.edList=[];


    button(
      d=w.simListDiv
       =dcE("DIV"),
      "NS", function(){
        Map.addSim(wa('tool/YASim'),parentWin(this));
      });
    h3(cont, d,"lsi");


    button(
      d=w.edListDiv
       =dcE("DIV"),
      "ne", function(){
        Map.addEdit(wa('ASM/YASMed'),parentWin(this));
      });
    button(d,"NF", function(){
        Map.addEdit(wa('tool/fb'),parentWin(this));
      });
    h3(cont, d,"led");

    cont.appendChild(dcE("HR"));

    delay(Map.mapSelDelay);
    return Map.MapList[  // append w to MapList
       w.MapCount=Map.MapCount++] // increment the unique number
         = w;
  },

  init_obj: function(){
    menu.subMenuItem(menu.list["Tools"],i8n.Map, "tool/map");
  }
});

